<?php

require_once (_PS_MODULE_DIR_ . '/ofdferma/classes/OfdFermaList.php');

class AdminOfdfermaListController extends ModuleAdminController {

    private $_list_by_id = array();
    
    public function __construct() {
        $this->table = 'ofdferma_receipt';
        $this->className = 'OfdFermaList';
        $this->module = 'ofdferma';
        //$this->identifier = 'id_manufacturer';
        $this->lang = false;
        $this->context = Context::getContext();
        $this->_defaultOrderBy = 'created_at';
        $this->_defaultorderWay = 'DESC';
        $this->deleted = false;
        $this->bootstrap = true;
        $this->list_no_link = true;
        
        $this->addRowAction('updateStatus');
        
        $this->fields_list = array(
            'id_ofdferma_receipt' => array(
                'title'     => 'ID',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false,
                'callback'  =>'renderIdLink'
            ),
            'type' => array(
                'title'     => 'Тип',
                'type'      => 'select',
                'orderby'   => false,
                'filter'    => true,
                'search'    => true,
                'list'      => array(
                    'Income'        => 'Приход',
                    'IncomeReturn'  => 'Возврат',
                ),
                'filter_key' => 'type',
                'callback'  =>'renderType'
            ),
            'status_message' => array(
                'title'     => 'Статус',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'order_id' => array(
                'title'     => 'Заказ',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => true,
                'search'    => true,
                'callback'  =>'renderOrderLink'
            ),
            'total' => array(
                'title'     => 'Сумма',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'FN' => array(
                'title'     => 'ФН',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'RNM' => array(
                'title'     => 'РНМ',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'FDN' => array(
                'title'     => 'ФДН',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'FPD' => array(
                'title'     => 'ФПД',
                'width'     => 50,
                'type'      => 'text',
                'orderby'   => false,
                'filter'    => false,
                'search'    => false
            ),
            'created_at'    => array(
                'title'     => 'Дата создания',
                'width'     => 100,
                'type'      => 'datetime',
                'orderby'   => false,
                'filter'    => true,
                'search'    => true
            )
        );
       
        parent::__construct();
        
        $this->postProcess();
    }

    public function renderIdLink($val, $row){
        if ('CONFIRMED' == $row['status']){
            $val = "<a href='".OfdfermaApi::getCheckLink($row)."' target='_blank'>{$val}</a>";
        }
        
        return $val;
    }
    
    public function renderType($val, $row){
        return OfdfermaApi::getInstance()->getTextType($val);
    }
    
    public function renderOrderLink($val, $row){
        $token_order = Tools::getAdminToken('AdminOrders'.(int)Tab::getIdFromClassName('AdminOrders').(int)$this->context->employee->id);
        return "<a href='?tab=AdminOrders&id_order={$row['order_id']}&vieworder&token={$token_order}' target='_blank'>{$val}</a>";
    }
    
    public function displayUpdateStatusLink($token = null, $id){ 
        
        if ( ! $this->_list_by_id){
            foreach($this->_list as $item){
                $this->_list_by_id[$item['id_ofdferma_receipt']] = $item;
            }
        }
        
        $result = '';
        if (isset($this->_list_by_id[$id]['status']) && $this->_list_by_id[$id]['status'] != 'CONFIRMED'){
            $result = "<a class='Pointer' href='?tab=AdminOfdfermaList&id={$id}&update_status&token={$token}'>Обновить статус</a>";
        }
        
        return $result;
    }
    
    public function postProcess() {		
        if (isset($_REQUEST['update_status']) && $_REQUEST['id']){
            $res = OfdfermaApi::getInstance()->check_update($_REQUEST['id']);
			
			if ( ! $res['status']){
				if ($res['mess']){
					$_SESSION['ofdferma_mess'] = array('status' => false, 'mess' => $res['mess']);
				}
			}else{
				$_SESSION['ofdferma_mess'] = array('status' => true, 'mess' => 'Статус чека успешно обновлен');
			}
        }else {
            parent::postProcess(true);
        }
    }
}
