<?php
if (!defined('_PS_VERSION_'))
    exit;

require_once (dirname(__FILE__) . '/classes/ofdfermaApi.php');

class ofdferma extends Module
{    
    public function __construct(){
        $this->name = 'ofdferma';
        $this->tab = 'administration';
        $this->version = '1.0.0';
        $this->author = 'pav-pas';
        $this->secure_key = Tools::encrypt($this->name);
        //$this->smart_shop_id = Context::getContext()->shop->id;
        $this->bootstrap = true;
        parent::__construct();

        $this->displayName = $this->l('FermaOFD');

        $this->description = $this->l('');
    }

    public function install()
    {
        Configuration::updateGlobalValue('ofdferma_login', '');
        Configuration::updateGlobalValue('ofdferma_password', '');
        Configuration::updateGlobalValue('ofdferma_inn', '');
        Configuration::updateGlobalValue('ofdferma_nalog', 'Common');
        Configuration::updateGlobalValue('ofdferma_vat', 'Vat0');
        Configuration::updateGlobalValue('ofdferma_collapse', '');
        Configuration::updateGlobalValue('ofdferma_collapse_name', '');
        Configuration::updateGlobalValue('ofdferma_status', '');
        Configuration::updateGlobalValue('ofdferma_email', '');
        
        $this->addquickaccess(); 

        if (!parent::install() || 
            !$this->registerHook('displayAdminAfterHeader') || 
            !$this->registerHook('displayAdminProductsExtra') || 
            !$this->registerHook('actionAdminProductsControllerSaveAfter') || 
            !$this->registerHook('displayBackOfficeOrderActions') || 
            !$this->registerHook('actionOrderStatusUpdate')
        )
            return false;
        
        
        $sql = array();
        require_once(dirname(__FILE__) . '/sql/install.php');
        foreach ($sql as $sq) :
            if (!Db::getInstance()->Execute($sq))
                return false;
        endforeach;

        $this->CreateOfdFermaTabs();
        
        return true;
    }
    
    public function uninstall()
    {
        if (!parent::uninstall())
            return false;

        Configuration::deleteByName('ofdferma_login', ''); 
        Configuration::deleteByName('ofdferma_password', ''); 
        Configuration::deleteByName('ofdferma_inn', ''); 
        Configuration::deleteByName('ofdferma_nalog', ''); 
        Configuration::deleteByName('ofdferma_vat', ''); 
        Configuration::deleteByName('ofdferma_collapse', '');
        Configuration::deleteByName('ofdferma_collapse_name', ''); 
        Configuration::deleteByName('ofdferma_status', ''); 
        Configuration::deleteByName('ofdferma_email', '');
        
        $this->unregisterHook('displayAdminAfterHeader'); 
        $this->unregisterHook('displayAdminProductsExtra'); 
        $this->unregisterHook('actionAdminProductsControllerSaveAfter'); 
        $this->unregisterHook('displayBackOfficeOrderActions'); 
        $this->unregisterHook('actionOrderStatusUpdate');
        
        $idtabs = array();

        require_once(dirname(__FILE__) . '/sql/uninstall_tab.php');
        foreach ($idtabs as $tabid):
            if ($tabid) {
                $tab = new Tab($tabid);
                $tab->delete();
            }
        endforeach;
        $sql = array();
        require_once(dirname(__FILE__) . '/sql/uninstall.php');
        foreach ($sql as $s) :
            if (!Db::getInstance()->Execute($s))
                return false;
        endforeach;

        $this->deletequickaccess();

        return true;
    }
    
    //pav-pas
    //Добавить ссылку в быстрый доступ
    public function addquickaccess()
    {
        $link = new Link();
        $qa = new QuickAccess();
        $qa->link = $link->getAdminLink('AdminModules') . '&configure=ofdferma';
        $languages = Language::getLanguages(false);
        foreach ($languages as $language) {
            $qa->name[$language['id_lang']] = 'Настройки Ferma OFD.ru';
        }
        $qa->new_window = '0';
        if ($qa->save()) {
            Configuration::updateValue('ofdferma_quick_access', $qa->id);
        }
    }

    public function deletequickaccess()
    {
        $qa = new QuickAccess(Configuration::get('ofdferma_quick_access'));
        $qa->delete();
    }
    
    //pav-pas
    //Добавить пункт в меню
    private function CreateOfdFermaTabs()
    {
        $langs = Language::getLanguages();

        $tabvalue = array();
        // assign tab value from include file
        require_once(dirname(__FILE__) . '/sql/install_tab.php');
        foreach ($tabvalue as $tab) {
            $newtab = new Tab();
            $newtab->class_name = $tab['class_name'];
            $newtab->id_parent = $tab['id_parent'];
            $newtab->module = $tab['module'];
            foreach ($langs as $l) {
                $newtab->name[$l['id_lang']] = $this->l($tab['name']);
            }
            $newtab->save();
        }
        return true;
    }
    
    public function getContent()
    {
        $html = '';
        if (Tools::isSubmit('saveofdferma')) {
            foreach(array('login','password','inn','nalog','vat','collapse','collapse_name','status','email') as $val){
                Configuration::updateValue('ofdferma_'.$val, Tools::getvalue('ofdferma_'.$val));
            }
            
            $html = $this->displayConfirmation($this->l('Изменения сохранены'));
            $helper = $this->SettingForm();
            $html .= $helper->generateForm($this->fields_form);
            
            return $html;
        } else {
            $helper = $this->SettingForm();
            $html .= $helper->generateForm($this->fields_form);
            
            return $html;
        }
    }
    
    public function hookDisplayAdminProductsExtra($params){
        $id_product = (int)$params['id_product'];
        
        if (Validate::isLoadedObject($product = new Product($id_product))) {
            $nds_id = ofdfermaApi::get_product_vat($id_product);
            
            $vat_data = array(
                array(
                    'id'    => '',
                    'name'  => 'Из настроек модуля'
                )
            );        
             
            
            foreach(ofdfermaApi::$reference_vat as $aItem){
                $vat_data[] = $aItem;
            }
            
            $this->context->smarty->assign(array(
                'nds_id'    => $nds_id,
                'vat_data'  => $vat_data
            ));
            return $this->display(__FILE__, 'views/templates/hook/displayAdminProductsExtra.tpl');
            
            return $helper;
        }
    }
    
    public function hookActionAdminProductsControllerSaveAfter($params){
        
        $product_id = isset($_POST['form']['id_product']) && $_POST['form']['id_product'] ? $_POST['form']['id_product'] : 0;
        $nds_id = isset($_POST['product_ofdferma_vat']) && $_POST['product_ofdferma_vat'] ? $_POST['product_ofdferma_vat'] : '';
        
        if ($product_id){
            Db::getInstance(_PS_USE_SQL_SLAVE_)->query('DELETE FROM `' . _DB_PREFIX_ . 'ofdferma_tovars` WHERE `tovar_id`=' . $product_id);
            Db::getInstance(_PS_USE_SQL_SLAVE_)->query('INSERT INTO `' . _DB_PREFIX_ . 'ofdferma_tovars` (`tovar_id`,`nds_id`) VALUES("'.$product_id.'","'.$nds_id.'")');
        }
    }
    
    public function hookDisplayBackOfficeOrderActions($params){

        $this->context->smarty->assign(array(
            'baseDir'   => _PS_BASE_URL_.__PS_BASE_URI__,
            'order_id'  => $params['id_order']
        ));
        return $this->display(__FILE__, 'views/templates/hook/displayBackOfficeOrderActions.tpl');
    }

    public function hookActionOrderStatusUpdate($params){
        
        $order_id = $params['id_order'];
        $status_id = $params['newOrderStatus'];
        
        if ($order_id && $status_id){
            $res = ofdfermaApi::getInstance()->set_status_order($order_id, $status_id);
			
			if ($res['status_match']){
				if ( ! $res['status']){
					$_SESSION['ofdferma_mess'] = array('status' => false, 'mess' => $res['mess']);
				}else{
					$_SESSION['ofdferma_mess'] = array('status' => true, 'mess' => 'Чек сформирован');
				}
			}
        }
    }
	
	public function hookDisplayAdminAfterHeader($params){
        
		$result = '';
        if (isset($_SESSION['ofdferma_mess'])){
			if ($_SESSION['ofdferma_mess']['status']){
				$result = "<div class='bootstrap'>
				  <div class='alert alert-success'>
					<button type='button' class='close' data-dismiss='alert'>&times;</button>
					{$_SESSION['ofdferma_mess']['mess']}
				  </div>
				</div>";
			}else{
				$result = "<div class='bootstrap'>
				  <div class='alert alert-danger'>
					<button type='button' class='close' data-dismiss='alert'>&times;</button>
					{$_SESSION['ofdferma_mess']['mess']}
				  </div>
				</div>";
			}
			
			//Удаляем сообщение из сессии
			unset($_SESSION['ofdferma_mess']);
		}
		
		return $result;
    }

    public function SettingForm()
    {
        
        $states = OrderState::getOrderStates($this->context->language->id);
        
        $aStatusData = array(
            array(
                'id'   => '',
                'name' => '- Не выбран -',
            )
        );
        
        if ($states){
            foreach($states as $aItem){
                $aStatusData[] = array(
                    'id'   => $aItem['id_order_state'],
                    'name' => $aItem['name'],
                );
            }
        }
       
        
        $default_lang = (int) Configuration::get('PS_LANG_DEFAULT');
        
        $this->fields_form[0]['form'] = array(
            'legend' => array(
                'title' => 'Настройки',
            ),
            'input' => array(
                array(
                    'type'      => 'text',
                    'label'     => 'Логин',
                    'name'      => 'ofdferma_login',
                    'size'      => 70,
                    'required'  => false
                ),
                array(
                    'type'      => 'text',
                    'label'     => 'Пароль',
                    'name'      => 'ofdferma_password',
                    'size'      => 70,
                    'required'  => false
                ),
                array(
                    'type'      => 'text',
                    'label'     => 'Инн',
                    'name'      => 'ofdferma_inn',
                    'size'      => 70,
                    'required'  => false
                ),
                array(
                    'type'      => 'select',
                    'label'     => 'Система налогооблажения',
                    'name'      => 'ofdferma_nalog',
                    'required'  => false,
                    'options'   => array(
                        'query' => ofdfermaApi::$reference_nalog,
                        'id'    => 'id',
                        'name'  => 'name',
                    )
                ),
                array(
                    'type'      => 'select',
                    'label'     => 'НДС (по умолчанию)',
                    'name'      => 'ofdferma_vat',
                    'required'  => false,
                    'options'   => array(
                        'query' => ofdfermaApi::$reference_vat,
                        'id'    => 'id',
                        'name'  => 'name',
                    )
                ),
                array(
                    'type'      => 'switch',
                    'label'     => 'Принудительная свертка позиций заказа',
                    'name'      => 'ofdferma_collapse',
                    'required'  => false,
                    'is_bool'   => true,
                    'values'    => array(
                        array(
                            'id' => 'active_on',
                            'value' => 1,
                            'label' => $this->l('Enabled')
                        ),
                        array(
                            'id' => 'active_off',
                            'value' => 0,
                            'label' => $this->l('Disabled')
                        )
                    )
                ),
                array(
                    'type'      => 'text',
                    'label'     => 'Текстовое название для позиции свертки',
                    'name'      => 'ofdferma_collapse_name',
                    'size'      => 70,
                    'required'  => false
                ),
                array(
                    'type'      => 'select',
                    'label'     => 'Статус, для которого формировать чек автоматически',
                    'name'      => 'ofdferma_status',
                    'required'  => false,
                    'options'   => array(
                        'query' => $aStatusData,
                        'id'    => 'id',
                        'name'  => 'name',
                    )
                ),
                array(
                    'type'      => 'text',
                    'label'     => 'Электронный адрес для уведомлений об ошибках',
                    'name'      => 'ofdferma_email',
                    'size'      => 70,
                    'required'  => false
                )
            ),
            'submit' => array(
                'title' => $this->l('Save'),
            )
        );
        
        $helper = new HelperForm();
        $helper->module = $this;
        $helper->name_controller = $this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->currentIndex = AdminController::$currentIndex . '&configure=' . $this->name;
        foreach (Language::getLanguages(false) as $lang){
            $helper->languages[] = array(
                'id_lang'       => $lang['id_lang'],
                'iso_code'      => $lang['iso_code'],
                'name'          => $lang['name'],
                'is_default'    => ($default_lang == $lang['id_lang'] ? 1 : 0)
            );
        }
        
        $helper->toolbar_btn = array(
            'save' =>
            array(
                'desc' => $this->l('Save'),
                'href' => AdminController::$currentIndex . '&configure=' . $this->name . '&save' . $this->name . 'token=' . Tools::getAdminTokenLite('AdminModules'),
            )
        );
        $helper->default_form_language = $default_lang;
        $helper->allow_employee_form_lang = $default_lang;
        $helper->title = $this->displayName;
        $helper->show_toolbar = true;
        $helper->toolbar_scroll = true;
        $helper->submit_action = 'save' . $this->name;

        foreach(array('login','password','inn','nalog','vat','collapse','collapse_name','status','email') as $val){
            $helper->fields_value['ofdferma_'.$val] = Configuration::get('ofdferma_'.$val);
        }
        
        return $helper;
    }
}